# Contributing

TofuTF welcomes contributions. 

If you have a good idea for a new feature, or enhancement, please file an issue in github that details the use case and background for the request.

Enhancements need to go through the triage process before any code contributions can be accepted.

## Code Style

Code should be formatted with `goimports`. 

When in doubt, observe the existing patterns, and style of the codebase. 

## Dependencies

Minimizing dependencies is an important aspect of maintaining any software project. Avoid introducing any dependencies, unless explicitly required.

## Tests

Any new features, or bugfixes should be accompanied with unit tests at the bare minimum, with integration tests being highly desired, or even required depending on the feature, or bugfix.