package main

import (
	"context"
	"os"
	"os/signal"
	"syscall"

	cmdutil "github.com/tofutf/tofutf/cmd"
	"github.com/tofutf/tofutf/internal/cli"
)

func main() {
	// Configure ^C to terminate program
	ctx, cancel := signal.NotifyContext(context.Background(), syscall.SIGTERM, syscall.SIGINT)
	go func() {
		<-ctx.Done()
		// Stop handling ^C; another ^C will exit the program.
		cancel()
	}()

	if err := cli.NewCLI().Run(ctx, os.Args[1:], os.Stdout); err != nil {
		cmdutil.PrintError(err)
		os.Exit(1)
	}
}
