package rbac

// Action identifies an action a subject carries out on a resource for
// authorization purposes.
type Action int

const (
	WatchAction Action = iota
	CreateOrganizationAction
	UpdateOrganizationAction
	GetOrganizationAction
	ListOrganizationsAction
	GetEntitlementsAction
	DeleteOrganizationAction

	CreateVCSProviderAction
	GetVCSProviderAction
	ListVCSProvidersAction
	DeleteVCSProviderAction

	CreateAgentPoolAction
	UpdateAgentPoolAction
	ListAgentPoolsAction
	GetAgentPoolAction
	DeleteAgentPoolAction

	CreateAgentTokenAction
	ListAgentTokensAction
	GetAgentTokenAction
	DeleteAgentTokenAction

	ListAgentsAction
	WatchAgentsAction

	CreateOrganizationTokenAction
	DeleteOrganizationTokenAction

	CreateRunTokenAction

	CreateTeamTokenAction
	GetTeamTokenAction
	DeleteTeamTokenAction

	CreateModuleAction
	CreateModuleVersionAction
	UpdateModuleAction
	ListModulesAction
	GetModuleAction
	DeleteModuleAction
	DeleteModuleVersionAction

	CreateWorkspaceVariableAction
	UpdateWorkspaceVariableAction
	ListWorkspaceVariablesAction
	GetWorkspaceVariableAction
	DeleteWorkspaceVariableAction

	CreateVariableSetAction
	UpdateVariableSetAction
	ListVariableSetsAction
	GetVariableSetAction
	DeleteVariableSetAction

	CreateVariableSetVariableAction
	UpdateVariableSetVariableAction
	GetVariableSetVariableAction
	DeleteVariableSetVariableAction

	AddVariableToSetAction
	RemoveVariableFromSetAction

	ApplyVariableSetToWorkspacesAction
	DeleteVariableSetFromWorkspacesAction

	GetRunAction
	ListRunsAction
	ApplyRunAction
	CreateRunAction
	DiscardRunAction
	DeleteRunAction
	CancelRunAction
	ForceCancelRunAction
	EnqueuePlanAction
	PutChunkAction
	TailLogsAction

	GetPlanFileAction
	UploadPlanFileAction

	GetLockFileAction
	UploadLockFileAction

	ListWorkspacesAction
	GetWorkspaceAction
	CreateWorkspaceAction
	DeleteWorkspaceAction
	SetWorkspacePermissionAction
	UnsetWorkspacePermissionAction
	UpdateWorkspaceAction

	ListTagsAction
	DeleteTagsAction
	TagWorkspacesAction
	AddTagsAction
	RemoveTagsAction
	ListWorkspaceTags

	LockWorkspaceAction
	UnlockWorkspaceAction
	ForceUnlockWorkspaceAction

	CreateStateVersionAction
	ListStateVersionsAction
	GetStateVersionAction
	DeleteStateVersionAction
	RollbackStateVersionAction
	UploadStateAction
	DownloadStateAction
	GetStateVersionOutputAction

	CreateConfigurationVersionAction
	ListConfigurationVersionsAction
	GetConfigurationVersionAction
	DownloadConfigurationVersionAction
	DeleteConfigurationVersionAction

	CreateUserAction
	ListUsersAction
	GetUserAction
	DeleteUserAction

	CreateTeamAction
	UpdateTeamAction
	GetTeamAction
	ListTeamsAction
	DeleteTeamAction
	AddTeamMembershipAction
	RemoveTeamMembershipAction

	CreateNotificationConfigurationAction
	UpdateNotificationConfigurationAction
	ListNotificationConfigurationsAction
	GetNotificationConfigurationAction
	DeleteNotificationConfigurationAction

	CreateGithubAppAction
	UpdateGithubAppAction
	GetGithubAppAction
	ListGithubAppsAction
	DeleteGithubAppAction
	CreateGithubAppInstallAction
	DeleteGithubAppInstallAction

	CreateGPGKeyAction
	ListGPGKeyAction
	UpdateGPGKeyAction
	GetGPGKeyAction
	DeleteGPGKeyAction
)
